"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getResetScreen = void 0;
const logging_1 = require("../logging");
const CLEAR_SCREEN = '\u001Bc';
function getResetScreen(clearScreen) {
    if (clearScreen) {
        return (heading) => logging_1.stderr(CLEAR_SCREEN + heading);
    }
    let firstRun = true;
    return (heading) => {
        if (firstRun) {
            logging_1.stderr(heading);
            firstRun = false;
        }
    };
}
exports.getResetScreen = getResetScreen;
