"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stdinPlugin = exports.stdinName = void 0;
exports.stdinName = '-';
let stdinResult = null;
function stdinPlugin() {
    return {
        name: 'stdin',
        resolveId(id) {
            if (id === exports.stdinName) {
                return id;
            }
        },
        load(id) {
            if (id === exports.stdinName) {
                return stdinResult || (stdinResult = readStdin());
            }
        }
    };
}
exports.stdinPlugin = stdinPlugin;
function readStdin() {
    return new Promise((resolve, reject) => {
        const chunks = [];
        process.stdin.setEncoding('utf8');
        process.stdin
            .on('data', chunk => chunks.push(chunk))
            .on('end', () => {
            const result = chunks.join('');
            resolve(result);
        })
            .on('error', err => {
            reject(err);
        });
    });
}
