"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createHasEffectsContext = exports.createInclusionContext = exports.BROKEN_FLOW_ERROR_RETURN_LABEL = exports.BROKEN_FLOW_BREAK_CONTINUE = exports.BROKEN_FLOW_NONE = void 0;
const PathTracker_1 = require("./utils/PathTracker");
exports.BROKEN_FLOW_NONE = 0;
exports.BROKEN_FLOW_BREAK_CONTINUE = 1;
exports.BROKEN_FLOW_ERROR_RETURN_LABEL = 2;
function createInclusionContext() {
    return {
        brokenFlow: exports.BROKEN_FLOW_NONE,
        includedLabels: new Set()
    };
}
exports.createInclusionContext = createInclusionContext;
function createHasEffectsContext() {
    return {
        accessed: new PathTracker_1.PathTracker(),
        assigned: new PathTracker_1.PathTracker(),
        brokenFlow: exports.BROKEN_FLOW_NONE,
        called: new PathTracker_1.PathTracker(),
        ignore: {
            breaks: false,
            continues: false,
            labels: new Set(),
            returnAwaitYield: false
        },
        includedLabels: new Set(),
        instantiated: new PathTracker_1.PathTracker(),
        replacedVariableInits: new Map()
    };
}
exports.createHasEffectsContext = createHasEffectsContext;
