"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ExecutionContext_1 = require("../ExecutionContext");
const Node_1 = require("./shared/Node");
class ContinueStatement extends Node_1.StatementBase {
    hasEffects(context) {
        if (this.label) {
            if (!context.ignore.labels.has(this.label.name))
                return true;
            context.includedLabels.add(this.label.name);
            context.brokenFlow = ExecutionContext_1.BROKEN_FLOW_ERROR_RETURN_LABEL;
        }
        else {
            if (!context.ignore.continues)
                return true;
            context.brokenFlow = ExecutionContext_1.BROKEN_FLOW_BREAK_CONTINUE;
        }
        return false;
    }
    include(context) {
        this.included = true;
        if (this.label) {
            this.label.include(context);
            context.includedLabels.add(this.label.name);
        }
        context.brokenFlow = this.label ? ExecutionContext_1.BROKEN_FLOW_ERROR_RETURN_LABEL : ExecutionContext_1.BROKEN_FLOW_BREAK_CONTINUE;
    }
}
exports.default = ContinueStatement;
