"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Node_1 = require("./shared/Node");
class ExportNamedDeclaration extends Node_1.NodeBase {
    bind() {
        // Do not bind specifiers
        if (this.declaration !== null)
            this.declaration.bind();
    }
    hasEffects(context) {
        return this.declaration !== null && this.declaration.hasEffects(context);
    }
    initialise() {
        this.context.addExport(this);
    }
    render(code, options, nodeRenderOptions) {
        const { start, end } = nodeRenderOptions;
        if (this.declaration === null) {
            code.remove(start, end);
        }
        else {
            code.remove(this.start, this.declaration.start);
            this.declaration.render(code, options, { start, end });
        }
    }
}
exports.default = ExportNamedDeclaration;
ExportNamedDeclaration.prototype.needsBoundaries = true;
