"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const values_1 = require("../values");
const Node_1 = require("./shared/Node");
class TemplateLiteral extends Node_1.NodeBase {
    getLiteralValueAtPath(path) {
        if (path.length > 0 || this.quasis.length !== 1) {
            return values_1.UnknownValue;
        }
        return this.quasis[0].value.cooked;
    }
    render(code, options) {
        code.indentExclusionRanges.push([this.start, this.end]);
        super.render(code, options);
    }
}
exports.default = TemplateLiteral;
