"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ArgumentsVariable_1 = __importDefault(require("../variables/ArgumentsVariable"));
const ThisVariable_1 = __importDefault(require("../variables/ThisVariable"));
const ReturnValueScope_1 = __importDefault(require("./ReturnValueScope"));
class FunctionScope extends ReturnValueScope_1.default {
    constructor(parent, context) {
        super(parent, context);
        this.variables.set('arguments', (this.argumentsVariable = new ArgumentsVariable_1.default(context)));
        this.variables.set('this', (this.thisVariable = new ThisVariable_1.default(context)));
    }
    findLexicalBoundary() {
        return this;
    }
    includeCallArguments(context, args) {
        super.includeCallArguments(context, args);
        if (this.argumentsVariable.included) {
            for (const arg of args) {
                if (!arg.included) {
                    arg.include(context, false);
                }
            }
        }
    }
}
exports.default = FunctionScope;
