"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const GlobalVariable_1 = __importDefault(require("../variables/GlobalVariable"));
const UndefinedVariable_1 = __importDefault(require("../variables/UndefinedVariable"));
const Scope_1 = __importDefault(require("./Scope"));
class GlobalScope extends Scope_1.default {
    constructor() {
        super();
        this.variables.set('undefined', new UndefinedVariable_1.default());
    }
    findVariable(name) {
        let variable = this.variables.get(name);
        if (!variable) {
            variable = new GlobalVariable_1.default(name);
            this.variables.set(name, variable);
        }
        return variable;
    }
}
exports.default = GlobalScope;
