"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SHARED_RECURSION_TRACKER = exports.PathTracker = exports.UNKNOWN_PATH = exports.EMPTY_PATH = exports.UnknownKey = void 0;
exports.UnknownKey = Symbol('Unknown Key');
exports.EMPTY_PATH = [];
exports.UNKNOWN_PATH = [exports.UnknownKey];
const EntitiesKey = Symbol('Entities');
class PathTracker {
    constructor() {
        this.entityPaths = Object.create(null, { [EntitiesKey]: { value: new Set() } });
    }
    getEntities(path) {
        let currentPaths = this.entityPaths;
        for (const pathSegment of path) {
            currentPaths = currentPaths[pathSegment] =
                currentPaths[pathSegment] ||
                    Object.create(null, { [EntitiesKey]: { value: new Set() } });
        }
        return currentPaths[EntitiesKey];
    }
}
exports.PathTracker = PathTracker;
exports.SHARED_RECURSION_TRACKER = new PathTracker();
