"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodedSourcemap = void 0;
const sourcemap_codec_1 = require("sourcemap-codec");
function decodedSourcemap(map) {
    if (!map)
        return null;
    if (typeof map === 'string') {
        map = JSON.parse(map);
    }
    if (map.mappings === '') {
        return {
            mappings: [],
            names: [],
            sources: [],
            version: 3
        };
    }
    let mappings;
    if (typeof map.mappings === 'string') {
        mappings = sourcemap_codec_1.decode(map.mappings);
    }
    else {
        mappings = map.mappings;
    }
    return Object.assign(Object.assign({}, map), { mappings });
}
exports.decodedSourcemap = decodedSourcemap;
