"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPlainPathFragment = exports.getAliasName = void 0;
const path_1 = require("./path");
const sanitizeFileName_1 = require("./sanitizeFileName");
function getAliasName(id) {
    const base = path_1.basename(id);
    return base.substr(0, base.length - path_1.extname(id).length);
}
exports.getAliasName = getAliasName;
function relativeId(id) {
    if (typeof process === 'undefined' || !path_1.isAbsolute(id))
        return id;
    return path_1.relative(process.cwd(), id);
}
exports.default = relativeId;
function isPlainPathFragment(name) {
    // not starting with "/", "./", "../"
    return (name[0] !== '/' &&
        !(name[0] === '.' && (name[1] === '/' || name[1] === '.')) &&
        sanitizeFileName_1.sanitizeFileName(name) === name);
}
exports.isPlainPathFragment = isPlainPathFragment;
