"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSafeName = void 0;
const base64_1 = require("./base64");
const reservedNames_1 = require("./reservedNames");
function getSafeName(baseName, usedNames) {
    let safeName = baseName;
    let count = 1;
    while (usedNames.has(safeName) || reservedNames_1.RESERVED_NAMES[safeName]) {
        safeName = `${baseName}$${base64_1.toBase64(count++)}`;
    }
    usedNames.add(safeName);
    return safeName;
}
exports.getSafeName = getSafeName;
